备战蓝桥杯---动态规划(基础3)

本专题主要介绍在求序列的经典问题上dp的应用。

我们上次用前缀和来解决,这次让我们用dp解决把

我们参考不下降子序列的思路,可以令fi为以i结尾的最大字段和,易得:

fi=max(ai,ai+fi-1);

下面是AC代码:

cpp 复制代码
#include<bits/stdc++.h>
using namespace std;
int a[200010],dp[200010],n,ans=-9999999;
int main(){
	cin>>n;
	for(int i=1;i<=n;i++) scanf("%d",&a[i]);
	dp[1]=a[1];
	for(int i=2;i<=n;i++){
		dp[i]=max(a[i],a[i]+dp[i-1]);
		ans=max(ans,dp[i]);
	}
	ans=max(ans,dp[1]);
	cout<<ans;
}

接题:

因为是求两个序列,我们把dp弄成二维。

我们令fij为第一个序列前i个与第二个序列前j个的最长公共子序列。

我们可以得出:当两个序列后面加了一个数,那么如果用到了其中一个,那么那个子序列一定就结束了,因为如果后面还有的话其中一个序列一定不符合(因为它后面已经没数了)

根据这个,我们知道如果加的数不同,相当于只有其中一个发挥作用,我们取两个max即可

于是,当s1i==s2j时fij=1+fi-1j-1;

当s1i!=s2j时 fij=max(fi-1j,fij-1)

对于初始条件

s11==s21 f11=1;

s11!=s21 f11=0;

下面是AC代码:

cpp 复制代码
#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <string>
using namespace std;
string s1,s2;
int dp[1000][1000];
int main(){
	while(cin>>s1>>s2){
		memset(dp,0,sizeof(dp));
		for(int i=1;i<=s1.length();i++){
			for(int j=1;j<=s2.length();j++){
				if(s1[i-1]==s2[j-1]) dp[i][j]=1+dp[i-1][j-1];
				else{
					dp[i][j]=max(dp[i-1][j],dp[i][j-1]);
				}
			}
		}
		printf("%d\n",dp[s1.length()][s2.length()]);
	}
}
相关推荐
生态学者5 小时前
Global Change Biology | 森林越“步调一致”,反而越怕干旱?树木生长与叶片活动的同步之谜
大数据·人工智能·算法·r语言·微信公众平台
所以遗憾是什么呢?5 小时前
【题解】Educational Codeforces Round 195 (Rated for Div. 2) ABCDE
c++·动态规划·acm·icpc·ccpc·xcpc·codeforecs
lsswear6 小时前
Agent 框架新手入门与实战部署指南
大数据·人工智能·算法
Lhan.zzZ7 小时前
Qt WebEngineView 在 Linux 上无法加载网页:从“看不见 HTML“到“禁用沙箱“
linux·c++·qt
Data analyse4567 小时前
rnweb 回放数据量太大怎么办?分片存储与断点续传的实现思路
前端·网络·算法·数据分析
sysu_chenxy9 小时前
二重循环输出二维图形
c++
Navigator_Z9 小时前
LeetCode //C - 1293. Shortest Path in a Grid with Obstacles Elimination
c语言·算法·leetcode
Nil2089 小时前
leetcode 64最小路径和
算法·leetcode·职场和发展
光影少年9 小时前
AI Agent、自动化与未来工作
人工智能·算法·架构
牧羊人.33310 小时前
计算机视觉基础 第16章|EigenFace,FisherFace,LBPH传统人脸识别算法
人工智能·算法·计算机视觉